'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 1 June 2000 at 1:45:35 pm'!
"Change Set:		102ReadStreamUndo-sma
Date:			1 June 2000
Author:			Stefan Matthias Aust

Undo #2192. The consequences of raising an exception for EOF during ReadStream>>next should be worked out in 2.9a but not for 2.8."!


!ReadStream methodsFor: 'accessing'!
next
	"Primitive. Answer the next object in the Stream represented by the
	receiver. Fail if the collection of this stream is not an Array or a String.
	Fail if the stream is positioned at its end, or if the position is out of
	bounds in the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 65>
	position >= readLimit
		ifTrue: [^nil]
		ifFalse: [^collection at: (position _ position + 1)]! !

